//------------------------------------------------------------
// J[h
//------------------------------------------------------------
class CCard
{
friend class CCardSuit;
private:
    CCard*  pPrev;  // RDɂꍇC̎̃J[h̃|C^
    CCard*  pNext;  // RDɂꍇC̑ÕJ[h̃|C^
    BYTE    n;      // J[h̎ށD0-51D4 ŐC]肪}[ND

public:
    CCard()
    {
        pPrev = NULL;
        pNext = NULL;
        n = 255;
    }

	// 擾
    inline int GetCardNumber()
    {
        return GET_CARD_NUMBER(n);
    }

	// }[N擾
    inline int GetCardSymbol()
    {
        return GET_CARD_SYMBOL(n);
    }

	// eNX`UVWvZ
    inline void GetUV(float *pu, float *pv)
    {
        int num = GET_CARD_NUMBER(n);
        if (num == 12) {
            *pu = 0.0f;
            *pv = GET_CARD_SYMBOL(n) * 0.125f + 0.5f;
        } else {
            *pu = num * 0.078125f;
            *pv = GET_CARD_SYMBOL(n) * 0.125f;
        }
    }
};





//------------------------------------------------------------
// RD
//   class CCard  Chain List \ŕێ
//------------------------------------------------------------
class CCardSuit
{
private:
    CCard   m_HeadCard;     // RD̐擪̃J[h̑Oɂ_~[J[h
    CCard   m_TailCard;     // RD̖̃J[h̎ɂ_~[J[h
    CCard   m_Cards[52];    // J[h̎
    int     m_iCount;       // RD̐

public:
    CCardSuit()
    {
        Reset();
    }

private:
	// idx Ԗڂ̃J[hRDꖇD
    CCard* RemoveCard(int idx)
    {
        CCard* pCard = m_HeadCard.pNext;
        for (int i=0; i<idx; i++) pCard = pCard->pNext;
        pCard->pNext->pPrev = pCard->pPrev;
        pCard->pPrev->pNext = pCard->pNext;
        pCard->pPrev = NULL;
        pCard->pNext = NULL;
        m_iCount--;
        return pCard;
    }

public:
    // Zbg
    void Reset()
    {
        int i;

        // Set Card No
        for (i=0; i<52; i++) m_Cards[i].n = i;
        // Set Card Suit Chain
        for (i=1; i<51; i++) {
            m_Cards[i].pPrev = &m_Cards[i-1];
            m_Cards[i].pNext = &m_Cards[i+1];
        }
        m_HeadCard.pNext  = &m_Cards[0];
        m_Cards[0].pPrev  = &m_HeadCard;
        m_Cards[0].pNext  = &m_Cards[1];
        m_Cards[51].pPrev = &m_Cards[50];
        m_Cards[51].pNext = &m_TailCard;
        m_TailCard.pPrev  = &m_Cards[51];
        m_iCount = 52;
    }

    // J[h1
    CCard* Draw()
    {
        if (m_iCount == 0) return NULL;
        int n = randMT() % m_iCount;
        return RemoveCard(n);
    }

    // J[h1Rɖ߂
    void   Drop(CCard* pCard)
    {
        pCard->pPrev = m_TailCard.pPrev;
        pCard->pNext = &m_TailCard;
        m_TailCard.pPrev->pNext = pCard;
        m_TailCard.pPrev        = pCard;
        m_iCount++;
    }

    // n Ŏw肵J[h̎̂擾
    CCard* GetCard(int n)
    {
        return &(m_Cards[n]);
    }
};


